=pod

=head1 NAME

EVP_MAC-CMAC - The CMAC EVP_MAC implementation

=head1 DESCRIPTION

Support for computing CMAC MACs through the B<EVP_MAC> API.

=head2 Identity

This implementation is identified with this name and properties, to be
used with EVP_MAC_fetch():

=over 4

=item "CMAC", "default=yes"

=back

=head2 Supported parameters

The general description of these parameters can be found in
L<EVP_MAC(3)/PARAMETERS>.

The following parameter can be set with EVP_MAC_CTX_set_params():

=over 4

=item "key" (B<OSSL_MAC_PARAM_KEY>) <octet string>

=item "cipher" (B<OSSL_MAC_PARAM_CIPHER>) <UTF8 string>

=item "properties" (B<OSSL_MAC_PARAM_PROPERTIES>) <UTF8 string>

=back

The following parameters can be retrieved with
EVP_MAC_CTX_get_params():

=over 4

=item "size" (B<OSSL_MAC_PARAM_SIZE>) <unsigned integer>

=back

The "size" parameter can also be retrieved with with EVP_MAC_size().
The length of the "size" parameter is equal to that of an B<unsigned int>.

=head1 SEE ALSO

L<EVP_MAC_CTX_get_params(3)>, L<EVP_MAC_CTX_set_params(3)>,
L<EVP_MAC(3)/PARAMETERS>, L<OSSL_PARAM(3)>

=head1 COPYRIGHT

Copyright 2018-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License").  You may not use
this file except in compliance with the License.  You can obtain a copy
in the file LICENSE in the source distribution or at
L<https://www.openssl.org/source/license.html>.

=cut
